import Head from 'next/head'
import ImageCard from '../components/imageCard'
import styles from '../styles/Home.module.css'
import TopBar from '../components/topBar'
import { useState } from 'react'
import dateFormat from 'dateformat'

export default function Home({ images }) {
  let [ tags, updateTags ] = useState(
    [...(new Set( images.map(image => image.tags).flat() )).values()].map(tag => {return {
      name: tag,
      selected: false
    }})
  )

  const imagesToShow = images.filter(image =>
    image.tags.some(tag =>
      (tags.some(t => t.selected) ? tags.filter(t => t.selected) : tags)
      .some(({ name }) => tag == name)
    )
  )

  let imagesByDate = {}
  imagesToShow.forEach(image => {
    const dateIdentifier = image.date.substring(0, 10)
    if (!imagesByDate[dateIdentifier])
      imagesByDate[dateIdentifier] = []

    imagesByDate[dateIdentifier].push(image)
  });

  return (
    <div className={styles.container}>
      <Head>
        <title>Create Next App</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>

      <TopBar tags={tags} updateTags={updateTags} />

      <main className={styles.main}>

        { Object.keys(imagesByDate).map(date => (
          <section key={date}>
            <h1>{dateFormat(new Date(date), "dddd, mmmm dS, yyyy")}</h1>
            <div className={styles.grid}>
              {imagesByDate[date].map(image => <ImageCard key={image.filename} image={image}/>)}
            </div>
          </section>
        )) }
        
      </main>
    </div>
  )
}

export async function getServerSideProps () {
  const res = await fetch('http://localhost:3000/api/getImages')
  const images = await res.json()

  return { 
    props: {
      images
    }
  }
}